let extractData = (() => {
	var _ref = _asyncToGenerator(function* (arg) {
		if (arg instanceof Function) {
			return yield arg();
		} else {
			return arg;
		}
	});

	return function extractData(_x) {
		return _ref.apply(this, arguments);
	};
})();

/**
	example destination: './data'
	
	example loadDataToCache:
	
	async function() {
		return [
			{
				key: 'key1',
				getData: async () => {
					return {hello: world}
				}
			}
		]
	}
*/


let set = (() => {
	var _ref2 = _asyncToGenerator(function* (loadDataToCache, destination) {
		try {
			const dataToCache = yield extractData(loadDataToCache);

			yield Promise.all(dataToCache.map((() => {
				var _ref3 = _asyncToGenerator(function* ({ key, getData }) {
					const data = yield getData();
					const stringifiedFileContents = JSON.stringify(data);

					const filePath = `${destination}/${key}.json`;
					console.log('Writing data to ', filePath);
					yield writeFile(filePath, stringifiedFileContents);
				});

				return function (_x4) {
					return _ref3.apply(this, arguments);
				};
			})()));
		} catch (e) {
			console.error('There was an error');
			throw e;
		}
		console.log('Finished');
	});

	return function set(_x2, _x3) {
		return _ref2.apply(this, arguments);
	};
})();

let writeFile = (() => {
	var _ref4 = _asyncToGenerator(function* (filePath, stringifiedFile) {
		yield ensureDirectoryExistence(filePath);
		return new Promise(function (resolve, reject) {
			fs.writeFile(filePath, stringifiedFile, function (err) {
				if (err) {
					reject(err);
				}
				resolve(true);
			});
		});
	});

	return function writeFile(_x5, _x6) {
		return _ref4.apply(this, arguments);
	};
})();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const fs = require('fs');
const path = require('path');

function ensureDirectoryExistence(filePath) {
	return new Promise((resolve, reject) => {
		const dirname = path.dirname(filePath);

		fs.mkdir(dirname, err => {
			if (!err || err && err.code === 'EEXIST') {
				resolve();
			} else {
				reject(err);
			}
		});
	});
}

module.exports = set;